﻿using System.Windows;
using System.Windows.Data;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 컬렉션 뷰
        /// </summary>
        private CollectionView collectionView;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.groupByTaskTypeCheckBox.Checked   += groupByTaskTypeCheckBox_Checked;
            this.groupByTaskTypeCheckBox.Unchecked += groupByTaskTypeCheckBox_Unchecked;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Group By Task Type 체크 박스 체크시 처리하기 - groupByTaskTypeCheckBox_Checked(sender, e)

        /// <summary>
        /// Group By Task Type 체크 박스 체크시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void groupByTaskTypeCheckBox_Checked(object sender, RoutedEventArgs e)
        {
            this.collectionView = (CollectionView)CollectionViewSource.GetDefaultView(this.itemsControl.ItemsSource);

            if(this.collectionView.CanGroup)
            {
                PropertyGroupDescription groupDescription = new PropertyGroupDescription("@Type");

                this.collectionView.GroupDescriptions.Add(groupDescription);
            }
        }

        #endregion
        #region Group By Task Type 체크 박스 체크 해제시 처리하기 - groupByTaskTypeCheckBox_Unchecked(sender, e)

        /// <summary>
        /// Group By Task Type 체크 박스 체크 해제시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void groupByTaskTypeCheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            this.collectionView = (CollectionView)CollectionViewSource.GetDefaultView(this.itemsControl.ItemsSource);

            this.collectionView.GroupDescriptions.Clear();
        }

        #endregion
    }
}